/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.ArduinocontroleRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Arduinocontrole extends TableImpl<ArduinocontroleRecord> {

    private static final long serialVersionUID = 1706393835;

    /**
     * The reference instance of <code>public.arduinocontrole</code>
     */
    public static final Arduinocontrole ARDUINOCONTROLE = new Arduinocontrole();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<ArduinocontroleRecord> getRecordType() {
        return ArduinocontroleRecord.class;
    }

    /**
     * The column <code>public.arduinocontrole.ardcontid</code>.
     */
    public final TableField<ArduinocontroleRecord, Integer> ARDCONTID = createField("ardcontid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('arduinocontrole_ardcontid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.arduinocontrole.fkardid</code>.
     */
    public final TableField<ArduinocontroleRecord, Integer> FKARDID = createField("fkardid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.arduinocontrole.fkconid</code>.
     */
    public final TableField<ArduinocontroleRecord, Integer> FKCONID = createField("fkconid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * Create a <code>public.arduinocontrole</code> table reference
     */
    public Arduinocontrole() {
        this(DSL.name("arduinocontrole"), null);
    }

    /**
     * Create an aliased <code>public.arduinocontrole</code> table reference
     */
    public Arduinocontrole(String alias) {
        this(DSL.name(alias), ARDUINOCONTROLE);
    }

    /**
     * Create an aliased <code>public.arduinocontrole</code> table reference
     */
    public Arduinocontrole(Name alias) {
        this(alias, ARDUINOCONTROLE);
    }

    private Arduinocontrole(Name alias, Table<ArduinocontroleRecord> aliased) {
        this(alias, aliased, null);
    }

    private Arduinocontrole(Name alias, Table<ArduinocontroleRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.ARDUINOCONTROLE_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<ArduinocontroleRecord, Integer> getIdentity() {
        return Keys.IDENTITY_ARDUINOCONTROLE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<ArduinocontroleRecord> getPrimaryKey() {
        return Keys.ARDUINOCONTROLE_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<ArduinocontroleRecord>> getKeys() {
        return Arrays.<UniqueKey<ArduinocontroleRecord>>asList(Keys.ARDUINOCONTROLE_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<ArduinocontroleRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<ArduinocontroleRecord, ?>>asList(Keys.ARDUINOCONTROLE__ARDUINOCONTROLE_FKARDID_FKEY, Keys.ARDUINOCONTROLE__ARDUINOCONTROLE_FKCONID_FKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Arduinocontrole as(String alias) {
        return new Arduinocontrole(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Arduinocontrole as(Name alias) {
        return new Arduinocontrole(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Arduinocontrole rename(String name) {
        return new Arduinocontrole(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Arduinocontrole rename(Name name) {
        return new Arduinocontrole(name, null);
    }
}
